﻿using System;
using System.Diagnostics;
using System.Drawing;
using System.Runtime.InteropServices;
using System.Windows.Forms;
using Steema.TeeChart;
using Steema.TeeChart.Editors.Series;
using Steema.TeeChart.Styles;

namespace TestingTeeChartScaling
{
    public partial class Form1 : Form
    {
        private readonly double[] m_RectangleX = new double[6];
        private readonly double[] m_RectangleY = new double[6];
        private readonly Line m_Line = new Line();
        private double m_Sum = 0.0;

        public Form1()
        {
            InitializeComponent();

            m_Chart.Aspect.View3D = false;
            m_Chart.Aspect.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.AntiAlias;
            m_Chart.Legend.Visible = false;
            m_Chart.Location = new Point(0, 0);
            m_Chart.Name = "Testing TChart";
            m_Chart.TabIndex = 0;
            m_Chart.Chart.Header.Text = "Testing TChart";
            m_Chart.Series.Clear();
            m_Chart.Tools.Clear();

            Load += (sender, args) => AddSeriesToChart();

            Test.Click += (sender, args) => AddSeriesToChart();
        }

        private void AddSeriesToChart()
        {
            m_Sum += 10.0;

            m_RectangleX[0] = -150.0 + m_Sum;
            m_RectangleY[0] = -150.0 + m_Sum;

            m_RectangleX[1] = 150.0 + m_Sum;
            m_RectangleY[1] = -150.0 + m_Sum;

            m_RectangleX[2] = 150.0 + m_Sum;
            m_RectangleY[2] = 150.0 + m_Sum;

            m_RectangleX[3] = -150.0 + m_Sum;
            m_RectangleY[3] = 150.0 + m_Sum;

            m_RectangleX[4] = -150.0 + m_Sum;
            m_RectangleY[4] = -150.0 + m_Sum;

            m_RectangleX[5] = -350.0 + m_Sum;
            m_RectangleY[5] = 350.0 + m_Sum;

            m_Line.XValues.Count = 6;
            m_Line.XValues.Value = m_RectangleX;

            m_Line.YValues.Count = 6;
            m_Line.YValues.Value = m_RectangleY;

            m_Chart.Series.Clear();
            m_Chart.Series.Add(m_Line);

            m_Chart.Axes.Bottom.Automatic = true;
            m_Chart.Axes.Bottom.MinimumOffset = 10;
            m_Chart.Axes.Bottom.MaximumOffset = 10;
            m_Chart.Axes.Bottom.Visible = false;
            m_Chart.Axes.Bottom.Ticks.Length = 0;

            m_Chart.Axes.Left.Automatic = true;
            m_Chart.Axes.Left.MinimumOffset = 10;
            m_Chart.Axes.Left.MaximumOffset = 10;
            m_Chart.Axes.Left.Visible = false;
            m_Chart.Axes.Left.Ticks.Length = 0;

            m_Line.IsoHorizAxes = true;

            m_Chart.BeforeDrawSeries += (sender, d) => m_Chart.Chart.Axes.Bottom.AdjustMaxMin();

            m_Sum += 10.0;

            Debug.Write(m_Chart.Zoom.Zoomed);

        }
    }
}
